package pl.softwaremill.weldbugs.bug1;

import org.jboss.arquillian.api.Deployment;
import org.jboss.arquillian.testng.Arquillian;
import org.jboss.shrinkwrap.api.ArchivePaths;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.ByteArrayAsset;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.testng.annotations.Test;

import javax.inject.Inject;

/**
 * @author Adam Warski (adam at warski dot org)
 */
public class TestBug1 extends Arquillian {
    @Deployment
    public static JavaArchive createTestArchive() {
        JavaArchive ar = ShrinkWrap.create(JavaArchive.class)
                .addClass(TestBean1.class);

        // Creating beans.xml
        StringBuilder beansXmlBuilder = new StringBuilder();
        beansXmlBuilder.append("<beans>");
        beansXmlBuilder.append("</beans>");

        ar = ar.addManifestResource(
                new ByteArrayAsset(beansXmlBuilder.toString().getBytes()),
                ArchivePaths.create("beans.xml"));

        return ar;
    }

    @Inject
    private TestBean1 testBean1;

    @Test
    public void test1() {
        testBean1.doWork();
        System.out.println("OK");
    }
}
