package pl.softwaremill.weldbugs.bug2;

import org.jboss.arquillian.api.Deployment;
import org.jboss.arquillian.testng.Arquillian;
import org.jboss.shrinkwrap.api.ArchivePaths;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.ByteArrayAsset;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.testng.annotations.Test;
import pl.softwaremill.weldbugs.common.InterceptMe;
import pl.softwaremill.weldbugs.common.MeInterceptor;

import javax.inject.Inject;

/**
 * @author Adam Warski (adam at warski dot org)
 */
public class TestBug2 extends Arquillian {
    @Deployment
    public static JavaArchive createTestArchive() {
        JavaArchive ar = ShrinkWrap.create(JavaArchive.class)
                .addClass(TestBean2.class)
                .addClass(MeInterceptor.class)
                .addClass(InterceptMe.class);

        // Creating beans.xml
        StringBuilder beansXmlBuilder = new StringBuilder();
        beansXmlBuilder.append("<beans>");
        beansXmlBuilder.append("<interceptors>");
        beansXmlBuilder.append("<class>");
        beansXmlBuilder.append("pl.softwaremill.weldbugs.common.MeInterceptor");
        beansXmlBuilder.append("</class>");
        beansXmlBuilder.append("</interceptors>");
        beansXmlBuilder.append("</beans>");

        ar = ar.addManifestResource(
                new ByteArrayAsset(beansXmlBuilder.toString().getBytes()),
                ArchivePaths.create("beans.xml"));

        return ar;
    }

    @Inject
    private TestBean2 testBean2;

    @Test
    public void test1() {
        testBean2.interceptedMethod();
        System.out.println("OK");
    }
}
