package pl.softwaremill.weldbugs.bug3;

import org.jboss.arquillian.api.Deployment;
import org.jboss.arquillian.testng.Arquillian;
import org.jboss.shrinkwrap.api.ArchivePaths;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.ByteArrayAsset;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.testng.Assert;
import org.testng.annotations.Test;
import pl.softwaremill.weldbugs.common.InterceptMe;
import pl.softwaremill.weldbugs.common.MeInterceptor;

import javax.inject.Inject;

/**
 * @author Adam Warski (adam at warski dot org)
 */
public class TestBug3 extends Arquillian {
    @Deployment
    public static JavaArchive createTestArchive() {
        JavaArchive ar = ShrinkWrap.create(JavaArchive.class)
                .addClass(TestBean3_1.class)
                .addClass(TestBean3_2.class)
                .addClass(MeInterceptor.class)
                .addClass(InterceptMe.class);

        // Creating beans.xml
        StringBuilder beansXmlBuilder = new StringBuilder();
        beansXmlBuilder.append("<beans>");
        beansXmlBuilder.append("<interceptors>");
        beansXmlBuilder.append("<class>");
        beansXmlBuilder.append("pl.softwaremill.weldbugs.common.MeInterceptor");
        beansXmlBuilder.append("</class>");
        beansXmlBuilder.append("</interceptors>");
        beansXmlBuilder.append("</beans>");

        ar = ar.addManifestResource(
                new ByteArrayAsset(beansXmlBuilder.toString().getBytes()),
                ArchivePaths.create("beans.xml"));

        return ar;
    }

    @Inject
    private TestBean3_2 testBean3_2;

    @Test
    public void test1() {
        Assert.assertEquals(testBean3_2.getValue(), 20);
    }
}
